CodeForces - 731C Sock(并查集+贪心+STL优化)

                                                             Socks

                                                    Time limit    2000 ms        Memory limit    262144 kB

Arseniy is already grown-up and independent. His mother decided to leave him alone for m days and left on a vacation. She have prepared a lot of food, left some money and washed all Arseniy's clothes.

Ten minutes before her leave she realized that it would be also useful to prepare instruction of which particular clothes to wear on each of the days she will be absent. Arseniy's family is a bit weird so all the clothes is enumerated. For example, each of Arseniy's n socks is assigned a unique integer from 1to n. Thus, the only thing his mother had to do was to write down two integers li and ri for each of the days — the indices of socks to wear on the day i (obviously, li stands for the left foot and ri for the right). Each sock is painted in one of k colors.

When mother already left Arseniy noticed that according to instruction he would wear the socks of different colors on some days. Of course, that is a terrible mistake cause by a rush. Arseniy is a smart boy, and, by some magical coincidence, he posses k jars with the paint — one for each of k colors.

Arseniy wants to repaint some of the socks in such a way, that for each of m days he can follow the mother's instructions and wear the socks of the same color. As he is going to be very busy these days he will have no time to change the colors of any socks so he has to finalize the colors now.

The new computer game Bota-3 was just realised and Arseniy can't wait to play it. What is the minimum number of socks that need their color to be changed in order to make it possible to follow mother's instructions and wear the socks of the same color during each of m days.

Input

The first line of input contains three integers nm and k (2 ≤ n ≤ 200 000, 0 ≤ m ≤ 200 000, 1 ≤ k ≤ 200 000) — the number of socks, the number of days and the number of available colors respectively.

The second line contain n integers c1, c2, ..., cn (1 ≤ ci ≤ k) — current colors of Arseniy's socks.

Each of the following m lines contains two integers li and ri (1 ≤ li, ri ≤ nli ≠ ri) — indices of socks which Arseniy should wear during the i-th day.

Output

Print one integer — the minimum number of socks that should have their colors changed in order to be able to obey the instructions and not make people laugh from watching the socks of different colors.

Examples

Input

3 2 3
1 2 3
1 2
2 3

Output

2

Input

3 2 2
1 1 2
1 2
2 1

Output

0

Note

In the first sample, Arseniy can repaint the first and the third socks to the second color.

In the second sample, there is no need to change any colors.

 

题意比较简单,有n双袜子,要穿m天,一共有k个染色罐子

已经知道每天应该穿哪两只袜子(不一定是一对),颜色不搭配的话不好看,就将每天穿的袜子染成一样的颜色叭

因为同一双袜子是有关联的,所以不能乱染,可以把每天穿的袜子看成一个集合,同样他们的同伴所在的小集合中的两个袜子也属于这一个集合,朋友关系依次类推。用并查集将袜子分成几个大的集合之后,每一个大集合中的所有袜子应该被染成同一种颜色,这里就是一个简单的贪心思想喽,要使得染色次数最少,肯定是全部染成这个集合中出现次数最多的那个颜色,每个集合的染色数目求和即得最终的最少染色次数

代码需要使用 map代替计数数组 不然会被T

#include<cstdio>
#include<string>
#include<cmath>
#include<cstring>
#include<iostream>
#include<algorithm>
#include<vector>
#include<stack>
#include<queue>
#include<map>
#define ll long long
#define mem(a,b) memset(a,b,sizeof(a))
using namespace std;
inline int _read() {
    char ch = getchar();
    int sum = 0;
    while (!(ch >= '0' && ch <= '9'))ch = getchar();
    while (ch >= '0' && ch <= '9')sum = sum * 10 + ch - 48, ch = getchar();
    return sum;
}
const int inf=0x3f3f3f3f;
const int mm=2e5+10;

int n,m,k;
int s[mm];
int f[mm];
vector<int>v[mm];//v[i][j]表示第i个集合中的第j个袜子的颜色  
int find(int x){
	if(x==f[x])
		return x;
	return f[x]=find(f[x]);
} 
void merge(int x,int y){
	int t1=find(x);
	int t2=find(y);
	if(t1!=t2)
		f[t1]=t2;
}

int main()
{
	for(int i=1;i<mm;i++)
		f[i]=i;
	scanf("%d%d%d",&n,&m,&k);
	for(int i=1;i<=n;i++)
		scanf("%d",&s[i]);
	int x,y;
	while(m--){
		scanf("%d%d",&x,&y);
		merge(x,y);
	}
	for(int i=1;i<=n;i++)
		v[find(i)].push_back(s[i]);//属于一个集合的袜子加到一起  
	int res=0;
	for(int i=1;i<=n;i++){
		int cnt=v[i].size();
		if(!cnt)continue;	
		//int num[mm]={0};   数组会被T  
		map<int,int>mp;
		int maxx=0;
		for(int j=0;j<cnt;j++){
			mp[v[i][j]]++;//第i个集合里每一种颜色出现的次数  
			maxx=max(maxx,mp[v[i][j]]);
		}	
		res+=v[i].size()-maxx;
	}	
	printf("%d\n",res);

	return 0;
}

 

  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论

“相关推荐”对你有帮助么?

  • 非常没帮助
  • 没帮助
  • 一般
  • 有帮助
  • 非常有帮助
提交
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值